
#pragma once

#include "CoreMinimal.h"
#include "WeArtEffect.h"

struct WeArtImpactInfo
{
public:
	static const WeArtImpactInfo none;

	bool valid;
	FVector position;
	float time;
	float multiplier;
};

/// <summary>
/// Effect to be applied to the thimble
/// </summary>
class WeArtTouchEffect : public WeArtEffect
{
public:

	FWeArtTemperature effTemperature;
	FWeArtForce effForce;
	FWeArtTexture effTexture;
	WeArtImpactInfo lastWeArtImpactInfo;

	WeArtTouchEffect(FWeArtTemperature temp, FWeArtForce force, FWeArtTexture texture)
	{
		effTemperature = temp;
		effForce = force;
		effTexture = texture;
		lastWeArtImpactInfo = WeArtImpactInfo::none;
	};

	bool Set(FWeArtTemperature temp, FWeArtForce force, FWeArtTexture texture, WeArtImpactInfo impactInfo);

	virtual FWeArtTemperature	getTemperature(void)	override { return effTemperature; };
	virtual FWeArtForce			getForce(void)	override { return effForce; };
	virtual FWeArtTexture		getTexture(void)	override { return effTexture; };
};
