// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "WeArtTouchableObject.h"
#include "WeArtCommon.h"
#include "GameFramework/Actor.h"
#include "WeArtGraspEvents.generated.h"

DECLARE_DYNAMIC_MULTICAST_DELEGATE_TwoParams(FOnHandControllerGraspSignature, HandSide, handSide, UWeArtTouchableObject*, weArtTouchableObject);
DECLARE_DYNAMIC_MULTICAST_DELEGATE_TwoParams(FOnHandControllerReleaseSignature, HandSide, handSide, UWeArtTouchableObject*, weArtTouchableObject);

UCLASS()
class WEARTPLUGIN_API AWeArtGraspEvents : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	AWeArtGraspEvents();

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	UPROPERTY(BlueprintAssignable)
		FOnHandControllerGraspSignature OnMiddlewareHandControllerGrasp;

	UFUNCTION(BlueprintImplementableEvent)
		void OnHandControllerGrasp(HandSide handSide, UWeArtTouchableObject* weArtTouchableObject);

	UPROPERTY(BlueprintAssignable)
		FOnHandControllerReleaseSignature OnMiddlewareHandControllerRelease;

	UFUNCTION(BlueprintImplementableEvent)
		void OnHandControllerRelease(HandSide handSide, UWeArtTouchableObject* weArtTouchableObject);

};
