// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "UObject/NoExportTypes.h"
#include "WeArtSettings.generated.h"

/// <summary>
/// Container class that handles the settings of the SDK
/// </summary>
UCLASS(config = WeArtSettings)
class WEARTPLUGIN_API UWeArtSettings : public UObject
{
	GENERATED_BODY()

public:
	UWeArtSettings(const FObjectInitializer& obj);

	UPROPERTY(Config, EditAnywhere, Category = Settings)
		int32 ClientPort = 13031;

	UPROPERTY(Config, EditAnywhere, Category = Settings)
		bool DebugMessages = true;

	UPROPERTY(Config, EditAnywhere, Category = Settings)
		bool ControllerAutoStart = true;

	UPROPERTY(Config, EditAnywhere, Category = Settings)
		bool CalibrationAutoStart = true;
	
};
