#include "WeArtThimbleTrackingObject.h"
#include "WeArtController.h"

UWeArtThimbleTrackingObject::UWeArtThimbleTrackingObject() {
}


UWeArtThimbleTrackingObject::~UWeArtThimbleTrackingObject()
{
}

void UWeArtThimbleTrackingObject::BeginPlay()
{
	Super::BeginPlay();

	UGameInstance* gameInstance = GetOuter()->GetWorld()->GetGameInstance();
	if (!gameInstance) {
		return;
	}

	UWeArtController* weArtController = gameInstance->GetSubsystem<UWeArtController>();
	if (!weArtController) {
		return;
	}

	weArtController->thimbleTrackingObjects.Add(this);
}


void UWeArtThimbleTrackingObject::EndPlay(const EEndPlayReason::Type EndPlayReason)
{
	Super::EndPlay(EndPlayReason);

	UGameInstance* gameInstance = GetOuter()->GetWorld()->GetGameInstance();
	if (!gameInstance) {
		return;
	}

	UWeArtController* weArtController = gameInstance->GetSubsystem<UWeArtController>();
	if (!weArtController) {
		return;
	}

	weArtController->thimbleTrackingObjects.Remove(this);
}

void UWeArtThimbleTrackingObject::OnMessageReceived(WeArtMessage* msg)
{
	if (msg->getID() == "Tracking") {
		TrackingMessage* trackingMsg = static_cast<TrackingMessage*>(msg);
		Closure = trackingMsg->GetClosure(handSide, actuationPoint);
		Abduction = trackingMsg->GetAbduction(handSide, actuationPoint);
	};
}
