// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "WeArtCommon.h"
#include "WeArtTrackingCalibration.generated.h"

DECLARE_DYNAMIC_MULTICAST_DELEGATE_OneParam(FOnCalibrationStartSignature,HandSide,handSide);
DECLARE_DYNAMIC_MULTICAST_DELEGATE_OneParam(FOnCalibrationFinishSignature, HandSide, handSide);
DECLARE_DYNAMIC_MULTICAST_DELEGATE_OneParam(FOnCalibrationResultSuccessSignature, HandSide, handSide);
DECLARE_DYNAMIC_MULTICAST_DELEGATE_OneParam(FOnCalibrationResultFailSignature, HandSide, handSide);
DECLARE_DYNAMIC_MULTICAST_DELEGATE(FOnCalibrationStopSignature);

/// <summary>
/// Calibration status/result observer
/// </summary>
UCLASS()
class WEARTPLUGIN_API AWeArtTrackingCalibration : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	AWeArtTrackingCalibration();

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	UPROPERTY(BlueprintAssignable)
		FOnCalibrationStartSignature OnMiddlewareCalibrationStart;

	UFUNCTION(BlueprintImplementableEvent)
		void OnCalibrationStart(HandSide handSide);

	UPROPERTY(BlueprintAssignable)
		FOnCalibrationFinishSignature OnMiddlewareCalibrationFinish;

	UFUNCTION(BlueprintImplementableEvent)
		void OnCalibrationFinish(HandSide handSide);

	UPROPERTY(BlueprintAssignable)
		FOnCalibrationResultSuccessSignature OnMiddlewareCalibrationResultSuccess;

	UFUNCTION(BlueprintImplementableEvent)
		void OnCalibrationResultSuccess(HandSide handSide);

	UPROPERTY(BlueprintAssignable)
		FOnCalibrationResultFailSignature OnMiddlewareCalibrationResultFail;

	UFUNCTION(BlueprintImplementableEvent)
		void OnCalibrationResultFail(HandSide handSide);

	UPROPERTY(BlueprintAssignable)
		FOnCalibrationStopSignature OnMiddlewareCalibrationStop;

	UFUNCTION(BlueprintImplementableEvent)
		void OnCalibrationStop();

};
