#pragma once

#include "CoreMinimal.h"
#include "WeArtCommon.h"
#include "WeArtForce.generated.h"

/// <summary>
/// Force value to be applied to an effect
/// </summary>
USTRUCT()
struct FWeArtForce {
	GENERATED_BODY()

public:
	// The force is a 3D vector. Only the first component is currently used
	// to represent the actual force, usage for the remaining components might come later.
	UPROPERTY(EditAnywhere, Meta = (InlineEditConditionToggle))
		bool active;
	UPROPERTY(EditAnywhere, Meta = (DisplayName = "Value", EditCondition = "active", ClampMin = "0.0", ClampMax = "1.0"))
		float value;

	FWeArtForce() : active(false), value(WeArtConstants::defaultForce) {};

	bool operator== (const FWeArtForce& other) {
		return (active == other.active && value == other.value);
	};
};
