#pragma once

#include "CoreMinimal.h"
#include "WeArtCommon.h"
#include "WeArtTemperature.generated.h"

/// <summary>
/// Temperature value to be applied to an effect
/// </summary>
USTRUCT()
struct WEARTPLUGIN_API FWeArtTemperature {
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, Meta = (InlineEditConditionToggle))
		bool active;

	// The value 0.5 is room temperature. The value 0 is cold and value 1 is hot.
	UPROPERTY(EditAnywhere, Meta = (DisplayName = "Value", EditCondition = "active", ClampMin = "0.0", ClampMax = "1.0"))
		float value;

	FWeArtTemperature() : active(false), value(WeArtConstants::defaultTemperature) {};

	bool operator==(const FWeArtTemperature& other) const {
		return (active == other.active && value == other.value);
	};
};


