// Copyright Epic Games, Inc. All Rights Reserved.

using UnrealBuildTool;
using System.IO;

public class WEARTPlugin : ModuleRules
{
	public WEARTPlugin(ReadOnlyTargetRules Target) : base(Target)
	{
		PCHUsage = ModuleRules.PCHUsageMode.UseExplicitOrSharedPCHs;

		PublicIncludePaths.AddRange(
			new string[] {
                Path.Combine(ModuleDirectory, "Common"),
                Path.Combine(ModuleDirectory, "Components"),
                Path.Combine(ModuleDirectory, "Features"),
                Path.Combine(ModuleDirectory, "Messages")
            }
			);


		PrivateIncludePaths.AddRange(
			new string[] {
                Path.Combine(ModuleDirectory, "Common"),
                Path.Combine(ModuleDirectory, "Components"),
                Path.Combine(ModuleDirectory, "Features"),
                Path.Combine(ModuleDirectory, "Messages")
            }
			);


		PublicDependencyModuleNames.AddRange(
			new string[]
			{
			    "Core",
                "Networking",
                "Sockets",
				// ... add other public dependencies that you statically link with here ...
			}
			);


		PrivateDependencyModuleNames.AddRange(
			new string[]
			{
				"CoreUObject",
				"Engine",
				"Slate",
				"SlateCore",
                "Networking",
                "Sockets",
				// ... add private dependencies that you statically link with here ...
			}
			);


		DynamicallyLoadedModuleNames.AddRange(
			new string[]
			{
				// ... add any modules that your module loads dynamically here ...
			}
			);
	}
}
